; GameBase v1.1 Inno Setup Installation Script File
; (c) 2004 James Burrows
; excludes DAO 3.6 and Jet 4.0 and vb runtimes
; updates from v0.93, v0.94, v0.95 and v1.0

[Setup]

AppName=GameBase
AppVerName=GameBase v1.1
AppPublisher=BU22
AppPublisherURL=http://www.bu22.com/
AppSupportURL=http://www.bu22.com/
AppUpdatesURL=http://www.bu22.com/
DefaultDirName={pf}\GameBase
LicenseFile=License.txt
InfoBeforeFile=BetaUpdate.txt
Uninstallable=no


[Files]
;Windows System Folder (DLL Register)
Source: "winsysreg\mswinsck.ocx"; DestDir: "{sys}"; CopyMode: alwaysskipifsameorolder; Flags: restartreplace sharedfile regserver

;App Folder
Source: "GameBase.exe"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GBToolbox.exe"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GBFuncs.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "GBSql.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "Gemus.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "Empty.mdb"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GemusText.ini"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GameBase.ini"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "History.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "whatsnew.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "vbzip10.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "License.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite

;Documentation Folder
Source: "docs\gemus.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\index.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\gemusdat.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\create.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\faq.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\pictures.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\started.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\license.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite

[Run]
Filename: "{app}\whatsnew.txt"; Description: "See what's new in v1.1!"; Flags: postinstall shellexec
Filename: "{app}\GameBase.exe"; Description: "Run GameBase v1.1 now!"; Flags: postinstall


