VERSION 5.00
Begin VB.Form frmGameLinkSelector 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Game Link Selector"
   ClientHeight    =   2415
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6780
   Icon            =   "frmGameLinkSelector.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   6780
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkMaintain 
      Caption         =   "&Maintain circular links"
      Enabled         =   0   'False
      Height          =   615
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Value           =   1  'Checked
      Visible         =   0   'False
      Width           =   4095
   End
   Begin VB.Frame fraFields 
      Caption         =   "Prompt"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6495
      Begin VB.OptionButton optField 
         Caption         =   "&Related Game"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   6135
      End
      Begin VB.OptionButton optField 
         Caption         =   "&Sequel"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   6135
      End
      Begin VB.OptionButton optField 
         Caption         =   "&Prequel"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   6135
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   5520
      TabIndex        =   6
      Top             =   1920
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   4320
      TabIndex        =   5
      Top             =   1920
      Width           =   1095
   End
End
Attribute VB_Name = "frmGameLinkSelector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==============================================
'              == GameBase ==
'    The Universal Retro-Gaming Frontend
'           and Database Utility
'----------------------------------------------
' Copyright (C) 1997-2004 James Burrows
' Email: gamebase@itsa.me.uk
' Homepage: http://www.bu22.com/
'----------------------------------------------
' This program is free software; you can
' redistribute it and/or modify it under the
' terms of the GNU General Public License as
' published by the Free Software Foundation;
' either version 2 of the License, or (at your
' option) any later version.
'
' This program is distributed in the hope that
' it will be useful, but WITHOUT ANY WARRANTY;
' without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR
' PURPOSE. See the GNU General Public License
' for more details.
'
' You should have received a copy of the GNU
' General Public License along with this
' program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330,
' Boston, MA 02111-1307 USA
'==============================================

Option Explicit


Private Sub cmdCancel_Click()
    
    Unload Me
    
End Sub

Private Sub cmdOK_Click()

    If optField(0).Value = True Then
        g_strGameLinkField = "Prequel"
    ElseIf optField(1).Value = True Then
        g_strGameLinkField = "Sequel"
    Else
        g_strGameLinkField = "Related"
    End If
    g_strDefaultGameLinkField = g_strGameLinkField
    With chkMaintain
        g_blnMaintainGameLinks = (.Visible And .Enabled And (.Value = vbChecked))
    End With
    Unload Me

End Sub


Private Sub Form_Load()

    Const DesignScaleHeight As Single = 2415    'The required scaleheight for the form
    Const DesignScaleWidth As Single = 6780     'The required scalewidth for the form
    Dim strIs As String
    Dim strTo As String
    
    'set the form's proper width and height
    Height = DesignScaleHeight + (Height - ScaleHeight)
    Width = DesignScaleWidth + (Width - ScaleWidth)

    'read ini file text
    cmdOK.Caption = g_strButtonOKText
    cmdCancel.Caption = g_strButtonCancelText
    With g_xobjFunc
        If g_blnGameLinkSetFlag = True Then
            Caption = .GetINIMessage("Game Link Selector", "SetCaption", "Set Game Link")
            fraFields.Caption = g_strMarkedGame
        Else
            Caption = .GetINIMessage("Game Link Selector", "ClearCaption", "Clear Game Link")
            fraFields.Caption = .GetINIMessage("Game Link Selector", "ClearPrompt", "Clear which link?")
        End If
        chkMaintain.Caption = .GetINIMessage("Game Link Selector", "MaintainCircularLinks", "&Maintain circular links")
        optField(0).Caption = .GetINIMessage("Game Link Selector", "Precursor", "&Precursor")
        optField(1).Caption = .GetINIMessage("Game Link Selector", "Sequel", "&Sequel")
        optField(2).Caption = .GetINIMessage("Game Link Selector", "Related", "&Related Game")
        If g_blnGameLinkSetFlag = True Then
            strIs = .GetINIMessage("Game Link Selector", "Is", "is") & " "
            strTo = " " & .GetINIMessage("Game Link Selector", "To", "to") & " "
            optField(0).Caption = strIs & optField(0).Caption & strTo & g_udtGame.strName
            optField(1).Caption = strIs & optField(1).Caption & strTo & g_udtGame.strName
            optField(2).Caption = strIs & optField(2).Caption & strTo & g_udtGame.strName
        End If
    End With

    'maintain circular links check box
    With chkMaintain
        .Visible = True
        .Enabled = False
    End With

    'set the initial field
    Select Case g_strGameLinkField
        Case "Prequel"
            optField(0).Value = True
        Case "Sequel"
            optField(1).Value = True
        Case Else
            optField(2).Value = True
    End Select

    With g_udtGame
        'disable stuff if necessary
        If g_blnGameLinkSetFlag = False Then
            optField(0).Enabled = (.lngPrequel > 0)
            optField(1).Enabled = (.lngSequel > 0)
            optField(2).Enabled = (.lngRelated > 0)
            cmdOK.Enabled = ((.lngPrequel > 0) Or (.lngSequel > 0) Or (.lngRelated > 0))
        End If
    End With

    'just incase
    chkMaintain.Enabled = (optField(2).Value = True)

    'assume user presses cancel
    g_strGameLinkField = ""

End Sub


Private Sub optField_Click(Index As Integer)

    cmdOK.Enabled = ((optField(0).Value = True) Or (optField(1).Value = True) Or (optField(2).Value = True))
    chkMaintain.Enabled = ((chkMaintain.Visible) And (Index = 2))

End Sub


